## ros-noetic-depthai 2.20.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4) # For Hunter

# MSVC variable isn't available before 'project' call
# Generalize to Win32 platform for now
if(NOT WIN32)
    set(HUNTER_CONFIGURATION_TYPES "Release" CACHE STRING "Hunter dependencies list of build configurations")
endif()

set(HUNTER_SKIP_PACKAGE_nlohmann_json OFF)
set(BUILD_SHARED_LIBS ON)
# Set type to canonicalize relative paths for user-provided toolchain
set(CMAKE_TOOLCHAIN_FILE "" CACHE FILEPATH "CMake toolchain path")

# Create a custom toolchain to pass certain options to dependencies
set(gen_toolchain "${CMAKE_CURRENT_BINARY_DIR}/generated/toolchain.cmake")

if(EXISTS "${gen_toolchain}" AND ("${_INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE}" STREQUAL "${CMAKE_TOOLCHAIN_FILE}" OR NOT "${CMAKE_TOOLCHAIN_FILE}" STREQUAL ""))
    message(STATUS "Using existing generated toolchain")
else()
    message(STATUS "Generating new toolchain...")
    configure_file(
        "${CMAKE_CURRENT_LIST_DIR}/cmake/toolchain/custom.cmake.in"
        "${gen_toolchain}"
        @ONLY
    )
endif()

set(CMAKE_TOOLCHAIN_FILE "${gen_toolchain}" CACHE STRING "" FORCE)
if(DEFINED _INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE)
    message(STATUS "Using specified toolchain file: ${_INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE} combined into: ${CMAKE_TOOLCHAIN_FILE}")
else()
    message(STATUS "Using toolchain file: ${CMAKE_TOOLCHAIN_FILE}")
endif()

include("cmake/HunterGate.cmake")
HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.23.322.tar.gz"
    SHA1 "cb0ea1f74f4a2c49a807de34885743495fccccbe"
    LOCAL # Local config for dependencies
)

# Move binary dir if windows, to shorten the path
if(WIN32)
    set(HUNTER_BINARY_DIR "${HUNTER_GATE_ROOT}/_bin" CACHE STRING "Hunter binary directory")
endif()

# Create depthai project
project(depthai VERSION "2.20.2" LANGUAGES CXX C)
get_directory_property(has_parent PARENT_DIRECTORY)
if(has_parent)
    set(DEPTHAI_VERSION ${PROJECT_VERSION} PARENT_SCOPE)
endif()

# Set default build type depending on context
set(default_build_type "Release")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git" AND NOT DEFINED ENV{CI})
    set(default_build_type "Debug")
endif()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Set default installation directory
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory" FORCE)
endif()

# Set policies
# CMP0074 dictates that find_package searches environment variable "[packageName]_ROOT" along with regular variable [packageName]_ROOT
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW) # Only introduced in 3.12
endif()

if(POLICY CMP0028)
  cmake_policy(SET CMP0028 NEW)
endif()

# Set to export compile commands for tools like clang-tidy and format
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Add module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/sanitizers")

# Additional options
option(DEPTHAI_CLANG_FORMAT "Enable clang-format target"                  ON)
option(DEPTHAI_CLANG_TIDY "Enable clang-tidy checks during compilation" OFF)
option(DEPTHAI_SANITIZE "Enable Address and Undefined sanitizers for library, examples and tests" OFF)

# Should install depthai core libraries
option(DEPTHAI_INSTALL   "Enable install target for depthai-core targets" ON)

# Debug option
set(DEPTHAI_XLINK_LOCAL "" CACHE STRING "Path to local XLink source to use instead of Hunter")
set(DEPTHAI_SHARED_LOCAL "" CACHE STRING "Path to local depthai-shared source to use instead of submodule")
set(DEPTHAI_BOOTLOADER_SHARED_LOCAL "" CACHE STRING "Path to local depthai-bootloader-shared source to use instead of submodule")

# Enable backward stack printing on crash
if(ANDROID)
    # Backward not supported currently on Android
    set(DEPTHAI_ENABLE_BACKWARD OFF CACHE BOOL "" FORCE)
else()
    option(DEPTHAI_ENABLE_BACKWARD "Enable stacktrace printing on crash using Backward" ON)
    # Additional function information for 'backward' stacktrace
    if(DEPTHAI_ENABLE_BACKWARD)
        set(CMAKE_ENABLE_EXPORTS ON)
    endif()
endif()

# Force Colored output when using Ninja
# Global option - affects all targets
option(FORCE_COLORED_OUTPUT "Always produce ANSI-colored output (GNU/Clang only)" OFF)
if(FORCE_COLORED_OUTPUT)
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
       add_compile_options(-fdiagnostics-color=always)
    elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
       add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Specify exporting all symbols on Windows
if(WIN32 AND BUILD_SHARED_LIBS)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON CACHE BOOL "")
endif()

### Constants
set(PROJECT_EXPORT_GROUP "${PROJECT_NAME}Targets")

## Check if cloned or sources
find_package(Git)
find_package(ament_cmake QUIET)
if(GIT_FOUND)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        RESULT_VARIABLE _git_root_dir_error
        OUTPUT_VARIABLE _git_root_dir
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(DEPTHAI_DOWNLOADED_SOURCES ON)
    if(_git_root_dir_error EQUAL 0 AND "${_git_root_dir}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
        set(DEPTHAI_DOWNLOADED_SOURCES OFF)
    endif()
    message(DEBUG "Git root dir (${_git_root_dir_error}): ${_git_root_dir}")
    message(DEBUG "DepthAI as downloaded sources: ${DEPTHAI_DOWNLOADED_SOURCES}")
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE BUILD_COMMIT
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(
        COMMAND ${GIT_EXECUTABLE} show -s --format=%ci ${BUILD_COMMIT}
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE BUILD_COMMIT_DATETIME
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

### Get and find dependencies

# Include project dependencies
set(DEPTHAI_DEPENDENCY_INCLUDE "" CACHE FILEPATH "Optional cmake file to append to dependency processing, e.g. additional find_package()")
include(depthaiDependencies)

# Add threads preference
set(THREADS_PREFER_PTHREAD_FLAG ON)

# Add depthai-shared, and definitions that it is PC side
include(${CMAKE_CURRENT_LIST_DIR}/shared/depthai-shared.cmake)

# Add depthai-bootloader-shared
include(${CMAKE_CURRENT_LIST_DIR}/shared/depthai-bootloader-shared.cmake)

# Add flags helpers
include(Flags)

### End of dependencies

set(TARGET_CORE_NAME ${PROJECT_NAME}-core)
set(TARGET_CORE_ALIAS core)

# Create core library
add_library(${TARGET_CORE_NAME}
    # depthai-shared sources
    "${DEPTHAI_SHARED_SOURCES}"
    # depthai-bootloader-shared sources
    "${DEPTHAI_BOOTLOADER_SHARED_SOURCES}"
    # sources
    src/device/Device.cpp
    src/device/DeviceBase.cpp
    src/device/DeviceBootloader.cpp
    src/device/DataQueue.cpp
    src/device/CallbackHandler.cpp
    src/device/CalibrationHandler.cpp
    src/device/Version.cpp
    src/pipeline/Pipeline.cpp
    src/pipeline/AssetManager.cpp
    src/pipeline/Node.cpp
    src/pipeline/node/XLinkIn.cpp
    src/pipeline/node/XLinkOut.cpp
    src/pipeline/node/ColorCamera.cpp
    src/pipeline/node/Camera.cpp
    src/pipeline/node/MonoCamera.cpp
    src/pipeline/node/StereoDepth.cpp
    src/pipeline/node/NeuralNetwork.cpp
    src/pipeline/node/ImageManip.cpp
    src/pipeline/node/Warp.cpp
    src/pipeline/node/VideoEncoder.cpp
    src/pipeline/node/DetectionNetwork.cpp
    src/pipeline/node/Script.cpp
    src/pipeline/node/SpatialDetectionNetwork.cpp
    src/pipeline/node/SystemLogger.cpp
    src/pipeline/node/SpatialLocationCalculator.cpp
    src/pipeline/node/AprilTag.cpp
    src/pipeline/node/ObjectTracker.cpp
    src/pipeline/node/IMU.cpp
    src/pipeline/node/EdgeDetector.cpp
    src/pipeline/node/SPIIn.cpp
    src/pipeline/node/FeatureTracker.cpp
    src/pipeline/node/DetectionParser.cpp
    src/pipeline/datatype/Buffer.cpp
    src/pipeline/datatype/ImgFrame.cpp
    src/pipeline/datatype/ImageManipConfig.cpp
    src/pipeline/datatype/CameraControl.cpp
    src/pipeline/datatype/NNData.cpp
    src/pipeline/datatype/ImgDetections.cpp
    src/pipeline/datatype/SpatialImgDetections.cpp
    src/pipeline/datatype/SystemInformation.cpp
    src/pipeline/datatype/StreamMessageParser.cpp
    src/pipeline/datatype/SpatialLocationCalculatorData.cpp
    src/pipeline/datatype/SpatialLocationCalculatorConfig.cpp
    src/pipeline/datatype/AprilTags.cpp
    src/pipeline/datatype/AprilTagConfig.cpp
    src/pipeline/datatype/Tracklets.cpp
    src/pipeline/datatype/IMUData.cpp
    src/pipeline/datatype/StereoDepthConfig.cpp
    src/pipeline/datatype/EdgeDetectorConfig.cpp
    src/pipeline/datatype/TrackedFeatures.cpp
    src/pipeline/datatype/FeatureTrackerConfig.cpp
    src/utility/Initialization.cpp
    src/utility/Resources.cpp
    src/utility/Path.cpp
    src/utility/Platform.cpp
    src/utility/Environment.cpp
    src/xlink/XLinkConnection.cpp
    src/xlink/XLinkStream.cpp
    src/openvino/OpenVINO.cpp
    src/openvino/BlobReader.cpp
    src/bspatch/bspatch.c
)
add_library("${PROJECT_NAME}::${TARGET_CORE_ALIAS}" ALIAS ${TARGET_CORE_NAME})
# Specify that we are building core
target_compile_definitions(${TARGET_CORE_NAME} PUBLIC DEPTHAI_TARGET_CORE)
# Specifies name of generated IMPORTED target (set to alias)
set_target_properties(${TARGET_CORE_NAME} PROPERTIES EXPORT_NAME ${TARGET_CORE_ALIAS})
# Add to list of targets to export and install
list(APPEND targets_to_export ${TARGET_CORE_NAME})

# Add default flags to core
add_default_flags(${TARGET_CORE_NAME})

# And clang-tidy and format
if(DEPTHAI_CLANG_TIDY)
    include(ClangTidy)
    target_clangtidy_setup(${TARGET_CORE_NAME})
endif()

# Set compiler features (c++14), and disables extensions (g++14)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_EXTENSIONS OFF)
# Add interface transitive property (C++14)
if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
    target_compile_features(${TARGET_CORE_NAME} INTERFACE cxx_generic_lambdas)
else()
    target_compile_features(${TARGET_CORE_NAME} INTERFACE cxx_std_14)
endif()

# First specify options
option(DEPTHAI_BUILD_TESTS "Build tests" OFF)
option(DEPTHAI_BUILD_EXAMPLES "Build examples - Requires OpenCV library to be installed" OFF)
option(DEPTHAI_BUILD_DOCS "Build documentation - requires doxygen to be installed" OFF)
option(DEPTHAI_OPENCV_SUPPORT "Enable optional OpenCV support" ON)


option(DEPTHAI_BINARIES_RESOURCE_COMPILE "Compile Depthai device side binaries into library" ON)
option(DEPTHAI_USB2_PATCH_ONLY_MODE "Use patch file and full depthai.cmd binary for usb2 mode" ON)
option(DEPTHAI_CMD_PATH "Use local path for depthai.cmd instead of downloading" OFF)
if(DEPTHAI_USB2_PATCH_ONLY_MODE)
    option(DEPTHAI_USB2_PATCH_PATH "Use local path for depthai-usb2-patch.patch instead of downloading" OFF)
else()
    option(DEPTHAI_USB2_CMD_PATH "Use local path for depthai-usb2.cmd instead of downloading" OFF)
endif()

if(DEPTHAI_USB2_PATCH_ONLY_MODE)
    message(STATUS "Compiling ${TARGET_CORE_NAME} resources in PATCH_ONLY mode")
else()
    message(STATUS "Compiling ${TARGET_CORE_NAME} depthai and depthai-usb2 resources")
endif()

# Set constant
set(DEPTHAI_RESOURCES_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/resources")

# Include configuration

=== examples/CMakeLists.txt ===
# Add an option to test examples
option(DEPTHAI_TEST_EXAMPLES "Test examples - examples will be ran as a part of test suite" OFF)

# Dependencies
find_package(OpenCV REQUIRED)
find_package(Sanitizers)

# Create utility library
add_library(utility utility/utility.cpp)
target_include_directories(utility PUBLIC "utility")
add_default_flags(utility LEAN)
target_link_libraries(utility FP16::fp16 ${OpenCV_LIBS})

# Create environments for usb & poe labels
set(test_usb_env
    # Misc
    "UBSAN_OPTIONS=halt_on_error=1"
    # DepthAI
    "DEPTHAI_PROTOCOL=usb"
)
set(test_poe_env
    # Misc
    "UBSAN_OPTIONS=halt_on_error=1"
    # DepthAI
    "DEPTHAI_PROTOCOL=tcpip;DEPTHAI_SEARCH_TIMEOUT=15000"
)

# Helper for adding new examples
function(dai_add_example example_name example_src enable_test)

    # Add example
    add_executable(${example_name} ${example_src})
    add_default_flags(${example_name} LEAN)
    target_link_libraries(${example_name} PRIVATE utility depthai::opencv ${OpenCV_LIBS} Threads::Threads)

    # Add sanitizers for example
    if(COMMAND add_sanitizers)
        add_sanitizers(${example_name})
    endif()
    # Add to clangformat target
    if(COMMAND target_clangformat_setup)
        target_clangformat_setup(${example_name} "")
    endif()

    # parse the rest of the arguments
    set(arguments ${ARGV})
    list(REMOVE_AT arguments 0 1 2)

    # If 'DEPTHAI_TEST_EXAMPLES' is ON, then examples will be part of the test suite
    if(${enable_test} AND DEPTHAI_TEST_EXAMPLES)
        add_test(NAME ${example_name} COMMAND ${CMAKE_COMMAND}
            -DTIMEOUT_SECONDS=10
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/ExecuteTestTimeout.cmake $<TARGET_FILE:${example_name}> ${arguments}
        )

        # Sets a regex catching any logged warnings, errors or critical (coming either from device or host)
        set_tests_properties(${example_name} PROPERTIES FAIL_REGULAR_EXPRESSION "\\[warning\\];\\[error\\];\\[critical\\]")

        # Add ubsan halt on error
        set_tests_properties(${example_name} PROPERTIES ENVIRONMENT "${test_usb_env}" LABELS usb)

        # Add PoE test variants
        add_test(NAME ${example_name}_poe COMMAND ${CMAKE_COMMAND}
            -DTIMEOUT_SECONDS=50
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/ExecuteTestTimeout.cmake $<TARGET_FILE:${example_name}> ${arguments}
        )
        # Add ubsan halt on error
        set_tests_properties(${example_name}_poe PROPERTIES ENVIRONMENT "${test_poe_env}" LABELS poe)

    endif()

    # Copy over required DLLs (Windows)
    if(WIN32)
        # Copy dlls to target directory - Windows only
        # TARGET_RUNTIME_DLLS generator expression available since CMake 3.21
        if(CMAKE_VERSION VERSION_LESS "3.21")
            file(GLOB depthai_dll_libraries "${HUNTER_INSTALL_PREFIX}/bin/*.dll")
        else()
            set(depthai_dll_libraries "$<TARGET_RUNTIME_DLLS:${example_name}>")
        endif()
        add_custom_command(TARGET ${example_name} POST_BUILD COMMAND
            ${CMAKE_COMMAND} -E copy_if_different ${depthai_dll_libraries} $<TARGET_FILE_DIR:${example_name}>
            COMMAND_EXPAND_LISTS
        )
    endif()
endfunction()

# Create a custom target which runs all examples for 10 seconds max, and check if they executed without errors



# Add any custom binary data using the following snippet
## # Hunter test data download
## hunter_private_data(
##     URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/mobilenet.blob"
##     SHA1 "e89d3ee9f26d80397e44f89c6b375990064a4a42"
##     FILE "mobilenet.blob"
##     LOCATION mobilenet_blob
## )


# Hunter test data download

# NeuralNetwork node, mobilenet example
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/mobilenet-ssd_openvino_2021.4_6shave.blob"
    SHA1 "4f4506726e3083981064938a0faaf9af6180d2c6"
    FILE "mobilenet-ssd_openvino_2021.4_6shave.blob"
    LOCATION mobilenet_blob
)

# YoloV3 resource
hunter_private_data(
    URL "http://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/yolo-v3-tiny-tf_openvino_2021.4_6shave.blob"
    SHA1 "dedb2d4d96b23e42d15c15e454b8f02eca2713de"
    FILE "yolo-v3-tiny-tf_openvino_2021.4_6shave.blob"
    LOCATION tiny_yolo_v3_blob
)

# YoloV4 resource
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/yolo-v4-tiny-tf_openvino_2021.4_6shave.blob"
    SHA1 "d8d09b697dac298fe83cf8856740a21b1a61ab89"
    FILE "yolo-v4-tiny-tf_openvino_2021.4_6shave.blob"
    LOCATION tiny_yolo_v4_blob
)

# NeuralNetwork node, mobilenet example, 5 shaves
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/mobilenet-ssd_openvino_2021.4_5shave.blob"
    SHA1 "14ab3ef446b8a649d6694d94c2fc8b798efd74a3"
    FILE "mobilenet-ssd_openvino_2021.4_5shave.blob"
    LOCATION mobilenet_5shaves_blob
)

# NeuralNetwork node, mobilenet example, 8 shaves
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/mobilenet-ssd_openvino_2021.4_8shave.blob"
    SHA1 "7e7ea9a680668f3ca9e8f1d22cc8f3f1a02ac018"
    FILE "mobilenet-ssd_openvino_2021.4_8shave.blob"
    LOCATION mobilenet_8shaves_blob
)

# Video file with objects to detect
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/construction_vest.mp4"
    SHA1 "271d8d0b702e683ce02957db7c100843de5ceaec"
    FILE "construction_vest.mp4"
    LOCATION construction_vest
)

# Calibration Sample files
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/misc/depthai_calib.json"
    SHA1 "ec50a47496473116c51cec1c8249bff2679383c3"
    FILE "depthai_calib.json"
    LOCATION calib_v6
)

hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/misc/depthai_v5.calib"
    SHA1 "adfe9976b9aacfdaa76ac7138810999988177e71"
    FILE "depthai_v5.calib"
    LOCATION calib_v5
)

hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/misc/BW1098OBC.json"
    SHA1 "1e84b6c339ac51e3b254775090b91235a40fac71"
    FILE "BW1098OBC.json"
    LOCATION device_config
)

# person-detection
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/person-detection-retail-0013_openvino_2021.4_7shave.blob"
    SHA1 "946d102874b287292cdb5952fa66356c8d36025f"
    FILE "person-detection-retail-0013_openvino_2021.4_7shave.blob"
    LOCATION person_detection
)

# concat model
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/concat_openvino_2021.4_6shave.blob"
    SHA1 "e4af6fb2bed39648a2a4424d8bdc5bac56d616df"
    FILE "concat_openvino_2021.4_6shave.blob"
    LOCATION concat_model
)

# normalization model
hunter_private_data(
    URL "https://artifacts.luxonis.com/artifactory/luxonis-depthai-data-local/network/normalize_openvino_2021.4_4shave.blob"
    SHA1 "1435f6d11e0dfdbc60f2dfa45aecd3d530b6153b"
    FILE "normalize_openvino_2021.4_4shave.blob"
    LOCATION normalization_model
)

## message(STATUS "Location of test1.data: ${test1_data}")

# bootloader
dai_add_example(bootloader_version bootloader/bootloader_version.cpp ON)
dai_add_example(flash_bootloader bootloader/flash_bootloader.cpp OFF)
dai_add_example(flash_user_bootloader bootloader/flash_user_bootloader.cpp OFF)
dai_add_example(bootloader_config bootloader/bootloader_config.cpp ON read)
dai_add_example(poe_set_ip bootloader/poe_set_ip.cpp OFF)
dai_add_example(read_flash_memory bootloader/read_flash_memory.cpp OFF)
dai_add_example(write_flash_memory bootloader/write_flash_memory.cpp OFF)
dai_add_example(flash_boot_header bootloader/flash_boot_header.cpp OFF)

# calibration
dai_add_example(calibration_flash calibration/calibration_flash.cpp OFF)
dai_add_example(calibration_flash_version5 calibration/calibration_flash_v5.cpp OFF)
dai_add_example(calibration_load calibration/calibration_load.cpp ON)
dai_add_example(calibration_reader calibration/calibration_reader.cpp ON)
dai_add_example(calibration_dump calibration/calibration_dump.cpp ON)
dai_add_example(calibration_factory_reset calibration/calibration_factory_reset.cpp OFF)

target_compile_definitions(calibration_flash PRIVATE CALIB_PATH="${calib_v6}")
target_compile_definitions(calibration_flash_version5 PRIVATE CALIB_PATH="${calib_v5}" BOARD_PATH="${device_config}")
target_compile_definitions(calibration_load PRIVATE CALIB_PATH="${calib_v6}")

# ColorCamera
dai_add_example(rgb_camera_control ColorCamera/rgb_camera_control.cpp ON)
dai_add_example(rgb_preview ColorCamera/rgb_preview.cpp ON)
dai_add_example(rgb_video ColorCamera/rgb_video.cpp ON)
dai_add_example(rgb_isp_scale ColorCamera/rgb_isp_scale.cpp ON)

# EdgeDetector
dai_add_example(edge_detector EdgeDetector/edge_detector.cpp ON)

# FeatureTracker
dai_add_example(feature_detector FeatureTracker/feature_detector.cpp ON)
dai_add_example(feature_tracker FeatureTracker/feature_tracker.cpp ON)

# host_side
dai_add_example(device_queue_event host_side/device_queue_event.cpp ON)
dai_add_example(opencv_support host_side/opencv_support.cpp ON)
dai_add_example(queue_add_callback host_side/queue_add_callback.cpp ON)
dai_add_example(device_information host_side/device_information.cpp OFF)

# ImageManip
dai_add_example(image_manip ImageManip/image_manip_example.cpp ON)
dai_add_example(image_manip_rotate ImageManip/image_manip_rotate.cpp ON)
dai_add_example(image_manip_tiling ImageManip/image_manip_tiling.cpp ON)
dai_add_example(rgb_rotate_warp ImageManip/rgb_rotate_warp.cpp ON)
dai_add_example(image_manip_warp_mesh ImageManip/image_manip_warp_mesh.cpp ON)

# Warp
dai_add_example(warp_mesh Warp/warp_mesh.cpp ON)

# IMU
dai_add_example(imu_gyroscope_accelerometer IMU/imu_gyroscope_accelerometer.cpp ON)
dai_add_example(imu_rotation_vector IMU/imu_rotation_vector.cpp ON)

# mixed
dai_add_example(mono_depth_mobilenetssd mixed/mono_depth_mobilenetssd.cpp ON)
dai_add_example(rgb_encoding_mono_mobilenet mixed/rgb_encoding_mono_mobilenet.cpp ON)
dai_add_example(rgb_encoding_mono_mobilenet_depth mixed/rgb_encoding_mono_mobilenet_depth.cpp ON)
dai_add_example(rgb_encoding_mobilenet mixed/rgb_encoding_mobilenet.cpp ON)
dai_add_example(multiple_devices mixed/multiple_devices.cpp OFF)
dai_add_example(frame_sync mixed/frame_sync.cpp ON)

target_compile_definitions(mono_depth_mobilenetssd PRIVATE BLOB_PATH="${mobilenet_blob}")
target_compile_definitions(rgb_encoding_mono_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}")
target_compile_definitions(rgb_encoding_mono_mobilenet_depth PRIVATE BLOB_PATH="${mobilenet_blob}")
target_compile_definitions(rgb_encoding_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}")

# MobileNet
dai_add_example(camera_mobilenet_sync MobileNet/camera_mobilenet_sync_example.cpp ON)
dai_add_example(rgb_mobilenet MobileNet/rgb_mobilenet.cpp  ON)
dai_add_example(rgb_mobilenet_4k MobileNet/rgb_mobilenet_4k.cpp ON)
dai_add_example(mono_mobilenet MobileNet/mono_mobilenet.cpp  ON)
dai_add_example(video_mobilenet MobileNet/video_mobilenet.cpp ON)
# Usually not available - removed from tests
# TODO - add to a separate group if possible
dai_add_example(webcam_mobilenet MobileNet/webcam_mobilenet_example.cpp OFF)

target_compile_definitions(camera_mobilenet_sync PRIVATE BLOB_PATH="${mobilenet_blob}")
target_compile_definitions(rgb_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}"  ON)
target_compile_definitions(rgb_mobilenet_4k PRIVATE BLOB_PATH="${mobilenet_5shaves_blob}")
target_compile_definitions(mono_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}")
target_compile_definitions(video_mobilenet PRIVATE BLOB_PATH="${mobilenet_8shaves_blob}" VIDEO_PATH="${construction_vest}")
target_compile_definitions(webcam_mobilenet PRIVATE BLOB_PATH="${mobilenet_8shaves_blob}")

# MonoCamera

=== debian/changelog ===
ros-noetic-depthai (2.20.2-1buster) buster; urgency=high

  * Fix for ColorCamera at high resolution while using isp scaling
  * Fix for OV9282 SW sync on devices with OV9782 RGB camera
  * Fix for IMX378/477/577 on sockets other than CAM_A (RGB)
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 30 Jan 2023 18:30:00 -0000

ros-noetic-depthai (2.20.1-1buster) buster; urgency=high

  * Modified OpenVINO::VERSION_UNIVERSAL API improvements / backward compatibility
  * Bootloader version 0.0.24 (fixes for standalone / flashed usecases)
  * [FW] Status LEDs on some additional devices
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sat, 28 Jan 2023 18:30:00 -0000

ros-noetic-depthai (2.19.1-1buster) buster; urgency=high

  * Added Device getDeviceName API
  * OAK-FFC 4P (R5M1E5) IR/Dot support
  * Additional Stability bugfixes to go along with 2.19.0 for PoE devices
  * Protected productName field in EEPROM
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 27 Nov 2022 18:30:00 -0000

ros-noetic-depthai (2.19.0-1buster) buster; urgency=high

  * Stability improvements #616
  * isUserBootloaderSupported API
  * Device.setTimesync(true/false) convenience function to enable or disable subsequent timesyncing
  * Windows improvements with listing BOOTED devices ("udev permissions" issue)
  * Fix OV9282 as MonoCamera on RGB socket (issue was black image)
  * Fix crash under high load (regression with camera events streaming)
  * Fix YOLOv5/7 decoding in case of a single class
  * Fix image size when decimation filter is enabled
  * Fix for certain OV9782 and OV9282 permutations/configs
  * Reset Device timestamp on boot to zero
  * Reworded "No available devices" error message when there are other connected devices connected.
  * Update CI to Node16 compatible actions

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 19 Sep 2022 18:30:00 -0000

ros-noetic-depthai (2.17.4-1buster) buster; urgency=high

  * DEPTHAI_WATCHDOG=0 bugfix (245fb57)
  * V5 Calibration flashing fix
  * FW log level bugfix (#587)
  * Updated DeviceBootloader::Config to retain existing values
  * PoE watchdog issues addressed (74b699c)
  * XLink - kernel driver detach (fixes some USB connectivity issues) (ba9bd8b)
  * Added EEPROM clear capability
  * Added missing installation of DLL files (#550)
  * Asset RPC refactor
  * Exposed Device::getAllConnectedDevices()
  * Exposed FW & BL versions
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 19 Sep 2022 18:30:00 -0000

ros-noetic-depthai (2.17.3-1buster) buster; urgency=high

  * Updated FW - BMI270 IMU improvements
  * Added seq & timestamps for more messages
  * New boards support
  * Windows DLL improvements (install libusb dll alongside libdepthai-core.dll)
  * XLink - improved connecting directly to given IP
  * StereoDepth ImgFrame metadata w/h when decimation filter is enabled
  * Intrinsic read fix #379
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin, Sachin Guruswamy

 -- Sachin Guruswamy <sachin@luxonis.com>  Thu, 04 Aug 2022 18:30:00 -0000

ros-noetic-depthai (2.17.0-1buster) buster; urgency=high

  * Support for new S2/Pro devices
  * FW: support for OAK-D-S2 / OAK-D-Pro using the latest board DM9098 R6M2E6
  * Handle new resolutions THE_720_P and THE_800_P for ColorCamera, applicable to OV9782 on RGB/center socket
  * StereoDepth: Add option for disparity shift to reduce minimum depth
  * StereoDepth: extended and subpixel mode can be enabled simultaneously
  * YoloV6 support
  * Refactor ImageManip node
  * macOS / Linux shared library and CI improvements
  * Bootloader improvements
  * Flash boot improvements
  * Bootloader improvements (capability to flash and boot from eMMC)
  * Flashed application information
  * Memory querying
  * XLink device search race fix
  * Capability to flash BoardConfig along with the Pipeline
  * Added host monitor thread to disconnect offline PoE devices
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin, Sachin Guruswamy

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 10 Jul 2022 18:30:00 -0000

ros-noetic-depthai (2.16.0-1buster) buster; urgency=high

  * OpenVINO 2022.1 support
  * XLink device search improvements
  * cross subnets for PoE devices
  * drastically reduced discovery time
  * Separated name / IP and MXID, to be able to query both USB path / IP and MXID
  * Android support
  * libusb dependency is now managed by Hunter
  * IMU FW update for BNO sensor
  * Added DetectionParser node as a standalone component of DetectionNetwork
  * StereoDepth - subpixel fractional bits API
  * VideoEncoder - lifted 16 frame pool limitation
  * Contributors: Sachin, Sachin Guruswamy

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 14 Jun 2022 18:30:00 -0000

ros-noetic-depthai (2.15.5-1buster) buster; urgency=high

  * EEPROM FIX
  * Json fix (#478 <https://github.com/luxonis/depthai-core/issues/478>)
    * Fixed nlohmann json < v3.9.0 compat and toolchain generation
    * turn off clang format
    Co-authored-by: Martin Peterlin <mailto:martin.peterlin7@gmail.com>
    Co-authored-by: TheMarpe <mailto:martin@luxonis.com>
  * Empty-Commit
  * Update package.xml
  * Contributors: Sachin, Sachin Guruswamy

 -- Sachin Guruswamy <sachin@luxonis.com>  Wed, 01 Jun 2022 18:30:00 -0000

ros-noetic-depthai (2.15.4-1buster) buster; urgency=high

  * Release 2.15.4
  * Update docs; removed unsupported AprilTag families
  * FW: VideoEncoder: fix keyframe rate config, fix resource computations for JPEG
    (e.g: MJPEG for 4K video 30fps + MJPEG for still 12MP ~1fps)
    properly set resources used to allow
  * Update FW
  * Update FW; change behavior of stereo rectification based on stereo camera FOV


=== debian/control ===
Source: ros-noetic-depthai
Section: misc
Priority: optional
Maintainer: Sachin Guruswamy <sachin@luxonis.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libopencv-dev, libusb-1.0-0-dev, nlohmann-json3-dev, ros-noetic-ros-environment
Homepage: https://www.luxonis.com/
Standards-Version: 3.9.2

Package: ros-noetic-depthai
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, libusb-1.0-0-dev, nlohmann-json3-dev, ros-noetic-catkin
Description: DepthAI core is a C++ library which comes with firmware and an API to interact with OAK Platform

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-depthai//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-depthai//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-depthai 2.22.0

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,10 @@
     add_executable(${example_name} ${example_src})
     add_default_flags(${example_name} LEAN)
     target_link_libraries(${example_name} PRIVATE utility depthai::opencv ${OpenCV_LIBS} Threads::Threads)
+    # Set compiler features (c++14), and disables extensions (g++14)
+    set_property(TARGET ${example_name} PROPERTY CXX_STANDARD 14)
+    set_property(TARGET ${example_name} PROPERTY CXX_STANDARD_REQUIRED ON)
+    set_property(TARGET ${example_name} PROPERTY CXX_EXTENSIONS OFF)
 
     # Add sanitizers for example
     if(COMMAND add_sanitizers)
@@ -237,6 +241,7 @@
 dai_add_example(opencv_support host_side/opencv_support.cpp ON)
 dai_add_example(queue_add_callback host_side/queue_add_callback.cpp ON)
 dai_add_example(device_information host_side/device_information.cpp OFF)
+dai_add_example(device_logging host_side/device_logging.cpp OFF)
 
 # ImageManip
 dai_add_example(image_manip ImageManip/image_manip_example.cpp ON)
@@ -278,8 +283,3 @@
 target_compile_definitions(camera_mobilenet_sync PRIVATE BLOB_PATH="${mobilenet_blob}")
 target_compile_definitions(rgb_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}"  ON)
 target_compile_definitions(rgb_mobilenet_4k PRIVATE BLOB_PATH="${mobilenet_5shaves_blob}")
-target_compile_definitions(mono_mobilenet PRIVATE BLOB_PATH="${mobilenet_blob}")
-target_compile_definitions(video_mobilenet PRIVATE BLOB_PATH="${mobilenet_8shaves_blob}" VIDEO_PATH="${construction_vest}")
-target_compile_definitions(webcam_mobilenet PRIVATE BLOB_PATH="${mobilenet_8shaves_blob}")
-
-# MonoCamera

=== debian/changelog ===
ros-noetic-depthai (2.22.0-1focal) focal; urgency=high

  * UVC Node - Capability to create a pipeline that sends data over UVC (or flash it)
  * ToF Node - Capability to decode ToF data into a depth map
  * New devices: OAK-D-SR (fixes), OAK-D-LR R1, OAK-D SR PoE
  * Reorganized CameraBoardSocket naming
  * Logging improvements
  * Added data throughput profiling, per device and globally
  * Added DEPTHAI_DEVICE_NAME_LIST env var to filter devices by name
  * Bootloader v0.0.26 - Fix for bootloader crash (USB variant)
  * Fix for 4 cameras via ETH
  * Device constructor bugfixes (when taking pipeline, or pipeline with config preapplied, etc...)
  * XLink - Bugfix for wrongly discovered usb path on Windows
  * OV9782 startup stream issue fix
  * #779 - Fixes a parsing issue
  * #469 - Fixes a stuck case if same stream names are used
  * Deprecated RGB/LEFT/RIGHT/... CamerBoardSocket naming. Rely on CAM_[A-H] or setName API
  * Add option to clear crash dump
  * XLink - Added 255.255.255.255 discovery and increased PoE search time
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Wed, 14 Jun 2023 22:00:00 -0000

ros-noetic-depthai (2.21.2-1focal) focal; urgency=high

  * UPDATE: Use v2.21.2 due to issues this version carries
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 04 Apr 2023 22:00:00 -0000

ros-noetic-depthai (2.21.0-1focal) focal; urgency=high

  * Improved x/y accuracy for SpatialLocationCalculator/SpatialDetectionNetwork
  * Support for median and mode, default changed to median in SpatialLocationCalculator/SpatialDetectionNetwork
  * Multi stereo support, ability to run stereo between any 2 calibrated cameras
  * Support for LEFT/RIGHT alignment in stereo node
  * Support to invalidate edge pixels: setNumInvalidateEdgePixels in Stereo Node
  * BrightnessFilter - If the input frame pixel is too dark or too bright, the disparity will be invalidated. Default pixels with value 0 are invalidated in Stereo Node
  * Added disparityToDepthUseSpecTranslation, rectificationUseSpecTranslation, and depthAlignmentUseSpecTranslation options for advanced usage in Stereo Node
  * Fix for RGB-depth alignment when RGB is configured to 12 MP
  * Crash dump support - support to retrieve crash context from the device which can be shared with developers
  * Configurable 3A fps - setIsp3aFps
  * IMU - support to retrieve connected IMU type, and firmware version. Refactored firmware update API
  * BMI270 - enable interrupt mode, timestamps are more consistent now
  * BNO086* - fix for sequence number
  * AR0234 improved AE smoothness, increased max gain to 400x (first 25.6x analog),
  * OV9782 on RGB/CAM-A socket max FPS: 120 (previously was only for OV9282), also improves image quality in very bright light,
  * OV9782/9282 minimum exposure time decreased: 20us -> 10us, helps in very bright light. TODO update tuning to make use of it, currently only possible to use with manual exposure
  * HW sync (trigger mode) enabled for OAK-D-LR, for cameras with matching FPS
  * FW: fix for UART0 / '/dev/ttyS0' init failure in Script node
  * POE power cycle fix - in rare occasions POE devices got stuck after reboot, requiring a manual power cycle
  * [XLink] Increased max number of links from 32 to 64
  * Update FW with performance metrics when DEPTHAI_LEVEL=info is enabled
  * Handle EEPROM boardOptions bit 7 for separate I2C on L/R cameras
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 02 Apr 2023 22:00:00 -0000

ros-noetic-depthai (2.20.2-1focal) focal; urgency=high

  * Fix for ColorCamera at high resolution while using isp scaling
  * Fix for OV9282 SW sync on devices with OV9782 RGB camera
  * Fix for IMX378/477/577 on sockets other than CAM_A (RGB)
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 30 Jan 2023 23:00:00 -0000

ros-noetic-depthai (2.20.1-1focal) focal; urgency=high

  * Modified OpenVINO::VERSION_UNIVERSAL API improvements / backward compatibility
  * Bootloader version 0.0.24 (fixes for standalone / flashed usecases)
  * [FW] Status LEDs on some additional devices
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sat, 28 Jan 2023 23:00:00 -0000

ros-noetic-depthai (2.19.1-1focal) focal; urgency=high

  * Added Device getDeviceName API
  * OAK-FFC 4P (R5M1E5) IR/Dot support
  * Additional Stability bugfixes to go along with 2.19.0 for PoE devices
  * Protected productName field in EEPROM
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 27 Nov 2022 23:00:00 -0000

ros-noetic-depthai (2.19.0-1focal) focal; urgency=high

  * Stability improvements #616
  * isUserBootloaderSupported API
  * Device.setTimesync(true/false) convenience function to enable or disable subsequent timesyncing
  * Windows improvements with listing BOOTED devices ("udev permissions" issue)
  * Fix OV9282 as MonoCamera on RGB socket (issue was black image)
  * Fix crash under high load (regression with camera events streaming)
  * Fix YOLOv5/7 decoding in case of a single class
  * Fix image size when decimation filter is enabled
  * Fix for certain OV9782 and OV9282 permutations/configs
  * Reset Device timestamp on boot to zero
  * Reworded "No available devices" error message when there are other connected devices connected.
  * Update CI to Node16 compatible actions

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 19 Sep 2022 22:00:00 -0000

ros-noetic-depthai (2.17.4-1focal) focal; urgency=high

  * DEPTHAI_WATCHDOG=0 bugfix (245fb57)
  * V5 Calibration flashing fix
  * FW log level bugfix (#587)
  * Updated DeviceBootloader::Config to retain existing values
  * PoE watchdog issues addressed (74b699c)
